#import "YundianAlivePlugin.h"
//#import <YDRealPersonSDK/YDRealPersonSDK.h>
#import "AFNetworking/AFNetworking.h"
#import "YDToastView.h"
#import "YDDemoDefines.h"
#import <CommonCrypto/CommonCryptor.h>
#import "YDLocalizationManager.h"
#import "YDHomePageViewController.h"
#import "YDVideoViewController.h"
#import <CLCore/CLCoreManager.h>
#import <CLRealPersonSDK/CLRealPersonManager.h>

@interface YundianAlivePlugin () <FlutterStreamHandler>

@property(nonatomic,copy) FlutterEventSink callBack;

@end

static NSString *_aliveListen = @"yundian_alive.event.alive.result_listener";
static NSString *_ocrListen = @"yundian_alive.event.ocr.result_listener";

@implementation YundianAlivePlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"yundian_alive"
            binaryMessenger:[registrar messenger]];
  YundianAlivePlugin* instance = [[YundianAlivePlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
        
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
      [self configNav];
      result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
      //1、活体检测 第一步
  }else if ([@"alive_init" isEqualToString:call.method]){
      
      FlutterAppDelegate *appdeletate = (FlutterAppDelegate *)[UIApplication sharedApplication].delegate;
      FlutterViewController *flutter = (FlutterViewController *)appdeletate.window.rootViewController;
            
      FlutterEventChannel *evenChannal = [FlutterEventChannel eventChannelWithName:_aliveListen binaryMessenger:flutter.binaryMessenger];
      [evenChannal setStreamHandler:self];
      
      NSDictionary *arguements = call.arguments;
      
      NSString *appkey = [arguements objectForKey:@"appKey"];
      if (appkey && [appkey isKindOfClass:NSString.class]) {
          [CLCoreManager initWithAppkey:appkey];
      }
      result(@"alive init success");
//      2、活体检测 第二步
  }else if ([@"alive_start_detect" isEqualToString:call.method]){
      
      NSDictionary *arguements = call.arguments;
            
      FlutterAppDelegate *appdeletate = (FlutterAppDelegate *)[UIApplication sharedApplication].delegate;
      FlutterViewController *flutter = (FlutterViewController *)appdeletate.window.rootViewController;
            
      NSString *token = [arguements objectForKey:@"authToken"];
      if (token && [token isKindOfClass:NSString.class] && ![token isEqualToString:@"Unknown"]) {
          [CLRealPersonManager setToken:token];
      }
      
      NSString *language = [NSLocale preferredLanguages].firstObject;
      if ([language hasPrefix:@"en"]) {
          language = @"en";
      } else if ([language hasPrefix:@"zh"]) {
          language = @"zh";
      } else {
          language = @"th";
      }
      
      if ([[arguements objectForKey:@"hasPrePage"] intValue] == 1) {
          
          YDHomePageViewController *ctrl = [[YDHomePageViewController alloc] init];
          WeakSelf(self);
          ctrl.language = language;
          ctrl.reslutCallback = ^(NSString * _Nonnull resultStr) {
              if (weakSelf.callBack) {
                  weakSelf.callBack(resultStr);
              }else{
    //              result(resultStr);
              }
          };
          if ([[arguements objectForKey:@"hasResultPage"] intValue] == 1) {
              ctrl.showResult = YES;
          }else{
              ctrl.showResult = NO;
          }
          NSString *distance = [arguements objectForKey:@"distance"];
          if (distance && [distance isKindOfClass:[NSNumber class]]) {
              ctrl.distance = [NSString stringWithFormat:@"%@",distance];
          }
          
          UINavigationController *navi = [[UINavigationController alloc] initWithRootViewController:ctrl];
          [flutter presentViewController:navi animated:YES completion:nil];
      }else{
          YDVideoViewController *ctrl = [[YDVideoViewController alloc] init];
          WeakSelf(self);
          ctrl.language = language;
          ctrl.resultCallback = ^(NSString * _Nonnull resultStr) {
              if (weakSelf.callBack) {
                  weakSelf.callBack(resultStr);
              }else{
    //              result(resultStr);
              }
          };
          if ([[arguements objectForKey:@"hasResultPage"] intValue] == 1) {
              ctrl.showResult = YES;
          }else{
              ctrl.showResult = NO;
          }
          NSString *distance = [arguements objectForKey:@"distance"];
          if (distance && [distance isKindOfClass:[NSNumber class]]) {
              ctrl.distance = [NSString stringWithFormat:@"%@",distance];
          }
          
          UINavigationController *navi = [[UINavigationController alloc] initWithRootViewController:ctrl];
          [flutter presentViewController:navi animated:YES completion:nil];
      }
      result(@"alive start detect");
  }else if ([@"alive_encrypt_aes" isEqualToString:call.method]){
  }else if ([@"aliveRelease" isEqualToString:call.method]){
  }else if ([@"setTimeout" isEqualToString:call.method]){
  }else if ([@"setActionSize" isEqualToString:call.method]){
  }else if ([@"setSecurityLevel" isEqualToString:call.method]){
  }else if ([@"setActionSecond" isEqualToString:call.method]){
  }else if ([@"ocr_init" isEqualToString:call.method]){
  }else if ([@"ocr_start_detect" isEqualToString:call.method]){
  }else {
    result(FlutterMethodNotImplemented);
  }
}


-(NSString *)returnAESEncryptString:(NSString *)key
                       originString:(NSString *)originStr{
    
    NSString *const kInitVector = @"";
    size_t const kKeySize = kCCKeySizeAES128;
    
    NSData *contentData = [originStr dataUsingEncoding:NSUTF8StringEncoding];
    NSUInteger dataLength = contentData.length;
    // 为结束符'\0' +1
    char keyPtr[kKeySize + 1];
    memset(keyPtr, 0, sizeof(keyPtr));
    [key getCString:keyPtr maxLength:sizeof(keyPtr) encoding:NSUTF8StringEncoding];
    
    // 密文长度 <= 明文长度 + BlockSize
    size_t encryptSize = dataLength + kCCBlockSizeAES128;
    void *encryptedBytes = malloc(encryptSize);
    size_t actualOutSize = 0;
    
    NSData *initVector = [kInitVector dataUsingEncoding:NSUTF8StringEncoding];
    
    CCCryptorStatus cryptStatus = CCCrypt(kCCEncrypt,
                                          kCCAlgorithmAES,
                                          kCCOptionPKCS7Padding,  // 系统默认使用 CBC，然后指明使用 PKCS7Padding
                                          keyPtr,
                                          kKeySize,
                                          initVector.bytes,
                                          contentData.bytes,
                                          dataLength,
                                          encryptedBytes,
                                          encryptSize,
                                          &actualOutSize);
    
    if (cryptStatus == kCCSuccess) {
        // 对加密后的数据进行 base64 编码
        NSString *result = [[NSData dataWithBytesNoCopy:encryptedBytes length:actualOutSize] base64EncodedStringWithOptions:NSDataBase64EncodingEndLineWithLineFeed];
        return result;
    }
    return  originStr;
}

- (void)configNav {
    if (@available(iOS 15.0, *)) {
        UINavigationBarAppearance *appearance = [[UINavigationBarAppearance alloc] init];
         [appearance configureWithOpaqueBackground];
         appearance.backgroundColor = UIColor.whiteColor;
         NSMutableDictionary *attributes = [NSMutableDictionary dictionary];
         [attributes setValue:UIColor.blackColor forKey:NSForegroundColorAttributeName];
         appearance.titleTextAttributes = attributes;
         [UINavigationBar appearance].standardAppearance = appearance;
        [UINavigationBar appearance].scrollEdgeAppearance = appearance;
    }
}

//当flutter 开始listen时，会调用。我们记住这个回调
-(FlutterError *)onListenWithArguments:(id)arguments eventSink:(FlutterEventSink)events{
    
    if (events) {
        self.callBack = events;
    }
    return nil;
}

- (FlutterError * _Nullable)onCancelWithArguments:(id _Nullable)arguments {
    return nil;
}

@end
