//
//  YDDemoDefines.h
//  
//
//  Created by ydong on 2021/6/5.
//  Copyright © 2021年 ydong. All rights reserved.
//

#ifndef YDDemoDefines_h
#define YDDemoDefines_h

//#define TEST_ENV

#ifndef __OPTIMIZE__
#define DLog(...) NSLog(__VA_ARGS__)
#else
#define DLog(...) {}
#endif

#define WeakSelf(type) __weak __typeof__(type) weakSelf = type;
#define StrongSelf(type) __strong __typeof__(type) strongSelf = type;

#define HexColor(colorStrin) [UIColor colorWithHexString:colorStrin]

#define SCREEN_HEIGHT [UIScreen mainScreen].bounds.size.height
#define SCREEN_WIDTH [UIScreen mainScreen].bounds.size.width

#define statusBarHeight ([[UIApplication sharedApplication] statusBarFrame].size.height)

#define SafeAreaBottomHeight (SCREEN_HEIGHT >= 812.0 ? 34 : 0)

#define IS_IPHONE_X ((statusBarHeight == 44) ? YES : NO)

#define KWidthScale ((SCREEN_WIDTH) / 375.0)
#define KHeightScale ((SCREEN_HEIGHT) / 667.0)

#define UIColorFromHexA(hexValue, a)     [UIColor colorWithRed:(((hexValue & 0xFF0000) >> 16))/255.0f green:(((hexValue & 0xFF00) >> 8))/255.0f blue:((hexValue & 0xFF))/255.0f alpha:a]
#define UIColorFromHex(hexValue)        UIColorFromHexA(hexValue, 1.0f)

//#define bottomCopyRightText         @"© 2021 创蓝文化"
#define bottomCopyRightText         @"© 2021 云点文化"
#define imageViewWidth              (300 * KWidthScale)
// 传入imageView的宽高比应为3:4
#define imageViewHeight             (imageViewWidth * 4 / 3)
#define cameraViewRadius            (130 * KWidthScale)

#endif /* YDDemoDefines_h */
