//
//  YDLocalizationManager.m
//
//  Created by piggybear on 2017/11/4.
//  Copyright © 2017年 piggybear. All rights reserved.
//

#import "YDLocalizationManager.h"

@implementation YDLocalizationManager


+ (NSString *)localizedStringForKey:(NSString *)key language:(NSString *)language {
    if (language == nil) {
        return [self localizedStringForKey:key value:nil];
    }
    return [self localizedStringForKey:key value:nil language:language];
}

+ (NSString *)localizedStringForKey:(NSString *)key value:(NSString *)value {
    NSString *language = [NSLocale preferredLanguages].firstObject;
    if ([language hasPrefix:@"en"]) {
        language = @"en";
    } else if ([language hasPrefix:@"zh"]) {
        language = @"zh";
    } else {
        language = @"th";
    }
    return [self localizedStringForKey:key value:value language:language];
}

+ (NSString *)localizedStringForKey:(NSString *)key value:(NSString *)value language:(NSString *)language {
    
    NSBundle *bundle = [NSBundle bundleWithPath:[[NSBundle mainBundle] pathForResource:language ofType:@"lproj"]];
    value = [bundle localizedStringForKey:key value:value table:nil];

    return [[NSBundle mainBundle] localizedStringForKey:key value:value table:nil];
        
}
@end
