//
//  YDResToastView.h
//  
//
//  Created by ydong on 2021/6/5.
//  Copyright © 2021年 ydong. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol YDTimeoutToastViewDelegate <NSObject>

- (void)retryButtonDidTipped:(UIButton * _Nullable)sender;

- (void)backHomePageButtonDidTipped:(UIButton * _Nullable)sender;

@end

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, YDToastType) {
    YDToastTypeTimeout,
    YDToastTypeFaild,
    YDToastTypeNetError,
    YDToastTypeNoMoney
};

@interface YDResToastView : UIView

@property (nonatomic, weak) id<YDTimeoutToastViewDelegate> delegate;

@property(nonatomic,copy) NSString *language;


- (void)show:(YDToastType)toastType;

- (void)hidden;

@end

NS_ASSUME_NONNULL_END
