//
//  YDVideoViewController.m
//  
//
//  Created by ydong on 2021/9/16.
//  Copyright © 2021 ydong. All rights reserved.
//

#import "YDVideoViewController.h"
//#import <YDRealPersonSDK/YDRealPersonManager.h>
#import <CLRealPersonSDK/CLRealPersonManager.h>
#import "YDRealProcessView.h"
#import "YDPageView.h"
#import "YDResToastView.h"
#import "YDSucessViewController.h"
#import <AVFoundation/AVAudioPlayer.h>
#import <FLAnimatedImage/FLAnimatedImage.h>
#import "UIColor+YDLiveDetect.h"
#import "YDDemoDefines.h"
#import "Masonry/Masonry.h"
#import "YDLocalizationManager.h"
#define ActionDuration  3

@interface YDVideoViewController ()<YDTimeoutToastViewDelegate>

@property (nonatomic, strong) UIView *recordView;

@property (nonatomic, strong) UIImageView *picImgView;

@property (nonatomic, strong) UILabel *msgLabel;

@property (nonatomic, strong) CLRealPersonManager *manager;

@property (nonatomic, strong) YDRealProcessView *videoProcess;

@property (nonatomic, strong) AVAudioPlayer *player;

@property (nonatomic, assign) BOOL shouldPlay;

@property (nonatomic, strong) UIImageView *scanImgView;

@property (nonatomic, strong) FLAnimatedImageView *actImgView;

@property (nonatomic, strong) YDPageView *pageView;

@property (nonatomic, strong) YDRealProcessView *circleView;

@property (nonatomic, strong) UIButton *btn;

@property (nonatomic, strong) YDResToastView *toastView;

@property (nonatomic, assign) CGFloat lastBrightness;

@property (nonatomic, strong) NSMutableDictionary *returnDic;

@end

@implementation YDVideoViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = [self returnLocaleString:@"alive_check"];
//#warning 程序后台或者页面被覆盖应停止识别流程
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(enterBack) name:UIApplicationDidEnterBackgroundNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(becomeActive) name:UIApplicationWillEnterForegroundNotification object:nil];
    
    self.view.backgroundColor = HexColor(@"FFFFFF");
    
    _returnDic = [NSMutableDictionary dictionary];
    
    self.btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [self.btn setImage:[UIImage imageNamed:@"muc_on"] forState:UIControlStateNormal];
    [self.view addSubview:self.btn];
    self.shouldPlay = YES;
    [self.btn addTarget:self action:@selector(mucBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.btn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.view.mas_top).offset(11*KHeightScale + statusBarHeight + 44);
        make.left.mas_equalTo(self.view.mas_left).offset(15*KWidthScale);
        make.size.mas_equalTo(CGSizeMake(30, 31));
    }];
    
    self.videoProcess = [[YDRealProcessView alloc] initWithFrame:CGRectMake(SCREEN_WIDTH-46*KWidthScale, 18*KWidthScale + statusBarHeight + 44, 28*KWidthScale , 28*KWidthScale) withLineWidth:ceil(1.5*KWidthScale)];
    [self.view addSubview:self.videoProcess];
    self.videoProcess.showProcessLabel = YES;
    self.videoProcess.durationTime = 30;
    [self.videoProcess startAction];
    
    self.msgLabel = [[UILabel alloc] init];
    self.msgLabel.text = [self returnLocaleString:@"alive_tip_start"];
    self.msgLabel.font = [UIFont boldSystemFontOfSize:20];
    self.msgLabel.textAlignment = NSTextAlignmentCenter;
    self.msgLabel.backgroundColor = UIColor.whiteColor;
    self.msgLabel.textColor = HexColor(@"#333333");
    self.msgLabel.layer.cornerRadius = 2;
    self.msgLabel.numberOfLines = 2;
    [self.view addSubview:self.msgLabel];
    [self.msgLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.view.mas_top).offset(37*KHeightScale + statusBarHeight + 44);
        make.left.offset(48 * KWidthScale);
        make.right.offset(-48 * KWidthScale);
//        make.height.offset(28);
//        make.centerX.mas_equalTo(self.view.mas_centerX);
//        make.size.mas_equalTo(CGSizeMake(SCREEN_WIDTH-120*KWidthScale, 28));
    }];
    
    self.recordView = [[UIView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH-270*KWidthScale)/2, 37*KHeightScale+28+45*KWidthScale + statusBarHeight + 44, 270*KWidthScale, 270*KWidthScale)];
    [self.view addSubview:self.recordView];
    self.recordView.layer.cornerRadius = 270*KWidthScale/2.;
    self.recordView.layer.masksToBounds = YES;
    
    self.picImgView = [[UIImageView alloc] init];
    self.picImgView.image = [UIImage imageNamed:@"real_pic"];
    [self.recordView addSubview:self.picImgView];
    [self.picImgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.mas_equalTo(self.recordView.mas_centerX);
        make.centerY.mas_equalTo(self.recordView.mas_centerY);
        make.size.mas_equalTo(CGSizeMake(166.6*KWidthScale, 221.2*KWidthScale));
    }];
    
    self.actImgView = [[FLAnimatedImageView alloc] init];
    [self.view addSubview:self.actImgView];
    [self.actImgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.recordView.mas_bottom).offset(44*KHeightScale);
        make.centerX.mas_equalTo(self.recordView.mas_centerX);
        make.size.mas_equalTo(CGSizeMake(123*KWidthScale, 111*KWidthScale));
    }];
    
    self.pageView = [[YDPageView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH-123*KWidthScale)/2., 37*KHeightScale+28+45*KWidthScale+45*KWidthScale+226*KWidthScale+145*KWidthScale + statusBarHeight + 44, 123*KWidthScale, 20*KWidthScale) dotCount:3 dotSize:CGSizeMake(20*KWidthScale, 20*KWidthScale) selectColor:HexColor(@"#2D77FF") unSelectColor:HexColor(@"#DCE4EF")];
    [self.view addSubview:self.pageView];
    self.pageView.textColor = UIColor.whiteColor;
    
    self.circleView = [[YDRealProcessView alloc] initWithFrame:CGRectMake(self.recordView.frame.origin.x-12*KWidthScale, self.recordView.frame.origin.y-12*KWidthScale, self.recordView.frame.size.height + 24*KWidthScale, self.recordView.frame.size.height + 24*KWidthScale) withLineWidth:4*KWidthScale];
    [self.view addSubview:self.circleView];
    
    self.toastView = [[YDResToastView alloc] init];
    self.toastView.language = _language;
    self.toastView.frame = CGRectMake(44*KWidthScale, SCREEN_HEIGHT/2.5, SCREEN_WIDTH-88*KWidthScale, 180*KHeightScale);
    self.toastView.delegate = self;
    
    self.scanImgView = [[UIImageView alloc] initWithFrame:CGRectMake(0, -75*KWidthScale, self.recordView.frame.size.width, 75*KWidthScale)];
    self.scanImgView.image = [UIImage imageNamed:@"real_scan"];
    [self.recordView addSubview:self.scanImgView];
    
    self.manager = [[CLRealPersonManager alloc] initWithRecordView:self.recordView];
    [self startLiveDetectWithActionsHandler];
    
    self.btn.hidden = YES;
    self.actImgView.hidden = YES;
    self.pageView.hidden = YES;
    self.shouldPlay = NO;
    // 初始化音频，加快播放速度
    [self playActionMusic:@"0"];
    
    if (self.navigationController.viewControllers.count > 1) {
        self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"ico_back"] style:(UIBarButtonItemStyleDone) target:self action:@selector(back)];
    }else{
        self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@""] style:(UIBarButtonItemStyleDone) target:self action:nil];
    }
}

-(void)back {
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.lastBrightness = [UIScreen mainScreen].brightness;
    [UIScreen mainScreen].brightness = 1.0;
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    if (self.manager) {
        [self.manager stopLiveDetect];
    }
    [UIScreen mainScreen].brightness = self.lastBrightness;
}

- (void)reset {
    [self.manager stopLiveDetect];
    
    self.btn.hidden = YES;
    self.shouldPlay = NO;
    [self.btn setImage:[UIImage imageNamed:@"muc_on"] forState:UIControlStateNormal];
    self.actImgView.hidden = YES;
    self.pageView.hidden = YES;
    self.videoProcess.hidden = NO;
    [self.videoProcess startAction];
    [self.circleView resetAction];
    self.scanImgView.hidden = YES;
    [self.scanImgView.layer removeAllAnimations];
    self.msgLabel.text = [self returnLocaleString:@"alive_tip_start"];
    self.picImgView.image = [UIImage imageNamed:@"real_pic"];
}

- (void)updateTitleWithDic:(NSDictionary *)params {
    if ([params[@"type"] isEqualToString:@"1"]) {
        if([params[@"result"] isEqualToString:@"1"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_ok"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic_r"];
        }
        else if ([params[@"result"] isEqualToString:@"2"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_start"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"3"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_face"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"4"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_distance"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"5"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_illumination"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"6"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_tip_blur"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"7"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_all_face"];
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
        else if ([params[@"result"] isEqualToString:@"7"]) {
            // self.msgLabel.text = @"其他错误，请继续";
            self.picImgView.image = [UIImage imageNamed:@"real_pic"];
        }
    }
    else if ([params[@"type"] isEqualToString:@"2"]) {
        if([params[@"result"] isEqualToString:@"-1"]) {
            // 开始相关动作
            self.btn.hidden = NO;
            self.shouldPlay = YES;
            self.actImgView.hidden = NO;
            self.pageView.dotCount = [params[@"number"] intValue];
            self.pageView.selectCount = 1;
            self.pageView.hidden = NO;
            self.circleView.durationTime = ActionDuration*[params[@"number"] intValue];
            [self.circleView startAction];
            return;
        }
        else if([params[@"result"] isEqualToString:@"BLINK"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_blink"];
        }
        else if ([params[@"result"] isEqualToString:@"NOD"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_up_head"];

        }
        else if ([params[@"result"] isEqualToString:@"MOUTH"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_mouth"];

        }
        else if ([params[@"result"] isEqualToString:@"YAW"]) {
            self.msgLabel.text = [self returnLocaleString:@"alive_shake"];

        }
        else {
            self.msgLabel.text = [self returnLocaleString:@"alive_token_broken"];
            [self.manager stopLiveDetect];
            return;
        }
        self.pageView.selectCount = [params[@"index"] intValue]+1;
        NSString *path = [[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"act_%@", params[@"result"]] ofType:@"gif"];
        if (path) {
            NSData *dataOfGif = [NSData dataWithContentsOfFile: path];
            FLAnimatedImage *image = [FLAnimatedImage animatedImageWithGIFData:dataOfGif];
            self.actImgView.animatedImage = image;
        }
        [self playActionMusic:[NSString stringWithFormat:@"muc_%@", params[@"result"]]];
    }
    else if ([params[@"type"] isEqualToString:@"3"]) {
        [UIScreen mainScreen].brightness = self.lastBrightness;
        if([params[@"result"] isEqualToString:@"1"]) {
            [self.videoProcess stopLabelTime];
            [self.circleView stopLabelTime];
            self.videoProcess.hidden = YES;
            self.btn.hidden = YES;
            self.pageView.hidden = YES;
            self.actImgView.hidden = YES;
            self.msgLabel.text = [self returnLocaleString:@"alive_processing"];
            self.scanImgView.hidden = NO;
            [self.scanImgView.layer removeAllAnimations];
            CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"position"];
            animation.duration = 3;
            animation.repeatCount = HUGE_VALF;
            animation.fromValue = [NSValue valueWithCGPoint:self.scanImgView.layer.position];
            animation.toValue = [NSValue valueWithCGPoint:CGPointMake(self.scanImgView.layer.position.x, self.scanImgView.layer.position.y+75*KWidthScale+self.recordView.frame.size.height)];
            [self.scanImgView.layer addAnimation:animation forKey:@"move-layer"];
        }
    }
    else if ([params[@"type"] isEqualToString:@"4"]) {
        /// 不转发处理逻辑
        [self.manager resultWithDetectUrl:params[@"result"] isReTran:NO];
    }
}

- (void)updateCompleteyWithStatus:(CLStatus)status withDic:(NSDictionary *)params {
    [UIScreen mainScreen].brightness = self.lastBrightness;
    self.videoProcess.hidden = YES;
    self.btn.hidden = YES;
    self.shouldPlay = NO;
    self.actImgView.hidden = YES;
    self.pageView.hidden = YES;
    self.scanImgView.hidden = YES;
    [self.scanImgView.layer removeAllAnimations];
    
    if (status == CLCheckPass) {
        self.msgLabel.text = [self returnLocaleString:@"alive_finish"];
        
        NSDictionary *detailDic = [params objectForKey:@"detail"];
        NSArray *motions = [detailDic objectForKey:@"motions"];
        CGFloat score = 0;
        for (NSDictionary *dics in motions) {
            CGFloat currentScore = [[dics objectForKey:@"score"] doubleValue];
            score += currentScore;
        }
        CGFloat averageS = score/motions.count;
        [_returnDic setObject:[NSString stringWithFormat:@"%lf",averageS] forKey:@"score"];
        if ([detailDic objectForKey:@"featureImageId"]) {
            [_returnDic setObject:[detailDic objectForKey:@"featureImageId"] forKey:@"featureImageId"];
        }
        
        bool isPass = [[detailDic objectForKey:@"passed"] boolValue];
        
        if (isPass) {
            [_returnDic setObject:@"0" forKey:@"code"];
            [_returnDic setObject:[self returnLocaleString:@"alive_success"] forKey:@"msg"];
        }else{
            [_returnDic setObject:@"2" forKey:@"code"];
            [_returnDic setObject:[self returnLocaleString:@"alive_fail"] forKey:@"msg"];
        }
        
        NSData *jsonData = [NSJSONSerialization dataWithJSONObject:_returnDic options:NSJSONWritingPrettyPrinted error:nil];
        NSString *jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        
        if (self.showResult) {
            //移除 后台/前台 通知！！！
            [[NSNotificationCenter defaultCenter] removeObserver:self];

            YDSucessViewController *success = [[YDSucessViewController alloc] init];
            success.resultCallback = self.resultCallback;
            success.isSuccess = isPass;
            success.returnStr = jsonString;
            success.language = _language;
            [self.navigationController pushViewController:success animated:YES];
        }else{
            if (self.resultCallback) {
                self.resultCallback(jsonString);
            }
            if (self.navigationController.viewControllers.count == 1) {
                [self.navigationController dismissViewControllerAnimated:YES completion:nil];
            }
        }
    }
    else if (status == CLOperationTimeout) {
        NSLog(@"-- 超时 --");
        [self.toastView show:YDToastTypeTimeout];
    }
    else if (status == CLRPNoMoney) {
        NSLog(@"-- 余额不足 --");
        [self.toastView show:YDToastTypeNoMoney];
    }
    else if (status == CLCheckNotPass
             || status == CLOnlineUploadFaild
             || status == CLGetConfFaild
             || status == CLOnlineUploadFaild
             || status == CLRecordFaild
             || status == CLSDKError
             || status == CLRPVedioNoMate
             || status == CLRPVedioNoFace
             || status == CLRPVedioMoreFace
             || status == CLRPVideoIllumination
             || status == CLRPVedioAngle
             || status == CLRPVedioBlue
             || status == CLRPVedioMask
             || status == CLRPVedioSmall
             || status == CLNetError
             || status == CLRPVedioError) {
        self.msgLabel.text = [self returnLocaleString:@"alive_check_fail"];
        [self.scanImgView.layer removeAllAnimations];
        if (status == CLNetError) {
            [self.toastView show:YDToastTypeNetError];
        }
        else {
            [self.toastView show:YDToastTypeFaild];
        }
    }
}

- (void)startLiveDetectWithActionsHandler {
    [self.manager setTimeoutInterval:30];
//    [self.manager setDistanceNumber:YDDistanceLevelFarMore];
//    [self.manager setActionNumber:2 securityLevel:YDSecurityLevelHigh];
    
    if (_distance != nil) {
        [self.manager setActionDuration:[_distance intValue]];
    }else{
        [self.manager setActionDuration:ActionDuration];
    }
    
    __weak typeof (self)weakSelf = self;
    [self.manager startLiveDetectWithActionsHandler:^(NSDictionary * _Nonnull params) {
        NSLog(@"%@",params);
        if (params) {
            dispatch_sync(dispatch_get_main_queue(), ^{
                [weakSelf updateTitleWithDic:params];
            });
        }
    } completionHandler:^(CLStatus status, NSDictionary * _Nullable params) {
        dispatch_sync(dispatch_get_main_queue(), ^{
            [weakSelf updateCompleteyWithStatus:status withDic:params];
        });
    }];
}

#pragma mark - Music

- (void)mucBtnClick:(UIButton *)btn {
    if (btn.selected) {
        self.shouldPlay = YES;
        [btn setImage:[UIImage imageNamed:@"muc_on"] forState:UIControlStateNormal];
    }
    else {
        self.shouldPlay = NO;
        [btn setImage:[UIImage imageNamed:@"muc_off"] forState:UIControlStateNormal];
    }
    btn.selected = !btn.selected;
}

- (void)playActionMusic:(NSString *)musicName {
    
    if ([_language isEqualToString:@"th"]) {
        musicName = [musicName stringByAppendingString:@"_tai"];
    }else if ([_language isEqualToString:@"en"]) {
        musicName = [musicName stringByAppendingString:@"_en"];
    }
    
    NSURL *fileUrl = [[NSBundle mainBundle] URLForResource:musicName withExtension:@"mp3"];
    self.player = [[AVAudioPlayer alloc] initWithContentsOfURL:fileUrl error:nil];
    if (self.player) {
        [self.player prepareToPlay];
    }
    if (self.shouldPlay) {
        [self.player play];
    } else {
        [self.player stop];
    }
}

#pragma mark - dealloc

- (void)dealloc {
    NSLog(@"video is dealloc");
    [self.toastView hidden];
    [self.manager stopLiveDetect];
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)enterBack {
    [self.manager stopLiveDetect];
}

- (void)becomeActive {
    [self.toastView hidden];
    [self retryButtonDidTipped:nil];
}

#pragma mark - YDTimeoutToastViewDelegate
//再试一次
- (void)retryButtonDidTipped:(UIButton * _Nullable)sender {
    [UIScreen mainScreen].brightness = 1.0;
    [self reset];
    [self startLiveDetectWithActionsHandler];
}
//退出
- (void)backHomePageButtonDidTipped:(UIButton * _Nullable)sender {
    
    NSDictionary *dics = @{@"code":@"1",@"msg":[self returnLocaleString:@"alive_cancel"]};

    if (self.resultCallback) {
        NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dics options:NSJSONWritingPrettyPrinted error:nil];
        NSString *jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        self.resultCallback(jsonString);
    }
//    说明是push过来的
    if (self.navigationController.viewControllers.count > 1) {
        [self.navigationController popViewControllerAnimated:YES];
    }else{
        [self.navigationController dismissViewControllerAnimated:YES completion:nil];
    }
    
//    [self.navigationController popToRootViewControllerAnimated:YES];
}

-(NSString *)returnLocaleString:(NSString *)key{
    return [YDLocalizationManager localizedStringForKey:key language:_language];
}

@end
